/********************************************************************************
 * Copyright (c) 2021-2024 Bayerische Motoren Werke Aktiengesellschaft (BMW AG)
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 ********************************************************************************/

#include "Conversion/OscToNode/{{filename}}.h"

#include <memory>

{% for choice in node.children(ChildType.CHOICE) | sort(attribute='raw_type') %}
#include "Conversion/OscToNode/Parse{{ choice.raw_type }}.h"
{% endfor %}

namespace {{ ose_namespace }}
{
yase::BehaviorNode::Ptr parse({{ node.this.type }} {{ util.local(node.this) }})
{
    {% for choice in node.children(ChildType.CHOICE) | sort(attribute='raw_type') %}
    if (auto element = {{ util.local(node.this) }}->Get{{choice.name}}(); element)
    {
        return parse(element);
    }
    {% endfor %}
    throw std::runtime_error("Corrupted openSCENARIO file: No choice made within {{ node.this.type }}");
}

} // namespace {{ ose_namespace }}
